/********************************************************************/
/*                                                                  */
/*   Program Name :  sampling2                                      */
/*                                                                  */
/*      Version:  0.00  2002-05-26                                  */
/*                1.00  2002-10-04                                  */
/*                1.01  2005-06-12                                  */
/*                2.00  2005-12-28  support VSSP32                  */
/*                2.01  2006-01-02  minor change                    */
/*                2.02  2007-03-15  add independent LPF set         */
/*                2.04  2007-08-23  add bitshift set parameter      */
/*                                                                  */
/*      Copyright (c) 2002-2007 T.Kondo/NICT All Right Reserved     */
/*                                                                  */
/********************************************************************/
/*

 ho|ukah ItCTvOvO
        iZbg͕ʂ̃\tgōs)
         by T.Kondo 2001.8.17
                    2002.5.26
                    2002.9.15  PbƂ̃f[^ǉ
                    2002.10.04  Ver 1.0 release
                    2005.06.12  minor change
                    2005-12-21  support VSSP32
                    2007-03-15  add independent LPF set parameter
                    2007-08-23  add bitshift set parametert
                    
    点 sampling2 span sfreq[:lpf] adbit[:bitshift] numch [filename [tempdir [mode]]] 
          span   Wԁibj
                sfreq  TvOg
                       40,100,200,500  (kHz)    <= this is to keep backward compatibility
                       0.04,0.1,0.2,0.5  (MHz)
                       0.04,0.1,0.2,0.5,1,2,4,8,16,32,64 (for MHz)
                   PF32,64K5/VSSP32̂
                   QF̒lŃZbgƁAK5/VSSP32ɂ
                         tB^[X[ɃZbg
                         ̒l̏ꍇAtB^[͈ȉ̂悤ɃZbg
                      Fsample(MHz)   0.04 0.1 0.2 0.5 1 2 4 8 16 32 64 
                      Ffilter(MHz)     2   2   2   2  2 2 2 4  8 16  0
                                                   (0̓X[Ӗj
                lpf    LPFtB^[l(MHz)  2,4,8,16,0   (0̓X[Ӗj
                       TvOgƓƗɃZbgƂɎg
                adbit  `c\irbg)
                       1,2,4,8 
                bitshift  QrbgASrbgTvO[h̃xœK̂߂
                       rbgVtgʂݒ肷B0-6̒lZbgłBftHg0
                numch  `l
                       1 ܂ 4
                filename -- f[^t@C
                      ftHgtds.data
                tempdir -- Pbf[^t@CfBNg
                      ftHg̓JgfBg
                mode    -- t@Co̓[h
                       1: ꊇt@Ĉ iftHgj
                       2: Pbf[^t@Ĉ
                       3:  ꊇt@C{Pbƃt@C
                       4:  Pbf[^t@CóAϑꊇt@C쐬
                       6: Pbf[^t@Ĉ (Ԑj
                       7: UƓit@Co͖jVXe`FbNp
*/
#define  SAMPLING2_VERSION "Ver. 2007-08-23"
#include "chead.h"      // common header for IP-VLBI utilities

//#include "libipvlbi.h"  // IP-VLBIp֐Q(by T.Kondo)
//#include "libipvlbi_board.h"  // IP-VLBITv[{[hp֐Q(by T.Kondo)
/* 2005-06-12 */
#include "libipvlbi.c"  // IP-VLBIp֐Q(by T.Kondo)
#include "libipvlbi_board.c"  // IP-VLBITv[{[hp֐Q(by T.Kondo)



void parse_sfreq_lpf(char *cbuf, int *sfreq, int *lpf, double *freq)
{
//    parse "sfreq[:lpf]"  to sfreq and lpf
    int sfreq0,lpf0,n;
	int no_filter;
    double freq0;
    char cset[]=":";
    char *p= NULL;

    freq0=0.0;
    sfreq0=0;
    lpf0=0;
	n=0;

	freq0=atof(strtok(cbuf,cset));
    sfreq0=(int)freq0;
	while((p=strtok(NULL,cset))){
		n++;
		if(n==1) lpf0=atoi(p);
	}

    no_filter=0;
    if(freq0 < 0.0) {
        freq0=-freq0;
        no_filter=1;
	}
    sfreq0=(int)freq0;
    if(sfreq0==0) sfreq0=(int)(freq0*1000.0);  // when freq is less than 1.0

	if(n==0){    // no ":"  set LPF automatically 
       if(no_filter == 0) {
          lpf0=2;   // default is minimum settable filter frequency (MHz)
          if(sfreq0>=4) lpf0=2;
          if(sfreq0>=8) lpf0=4;
          if(sfreq0>=16) lpf0=8;
          if(sfreq0>=32) lpf0=16;
          if(sfreq0>=64) lpf0=0;
	   }
	} else {
		// LPF range chaeck
		if(lpf0 < 2 || lpf0 > 16) lpf0=0;
	}
    *sfreq=sfreq0;
    *lpf=lpf0;
    *freq=freq0;
}

void parse_adbit_bitshift(char *cbuf, int *adbit, int *bitshift)
{
//    parse "adbit[:bitshift]"  to adbit and bitshift
    int adbit0,bitshift0,n;
    char cset[]=":";
    char *p= NULL;

    adbit0=1;
    bitshift0=0;
	n=0;

	adbit0=atoi(strtok(cbuf,cset));
	while((p=strtok(NULL,cset))){
		n++;
		if(n==1) bitshift0=atoi(p);
	}
    *adbit=adbit0;
    *bitshift=bitshift0;
}


int main(int argc, char **argv)
{
    char outfile[80];
    char cbuf[100];
    char* dflt_fname="tds.data";
    char* dflt_tempdir="./";
    char outdir[60];
    int i,rv, mode;
    int span, sfreq, adbit, numch;
    int no_filter;
    double freq;
    spget_t spg;  //2005-12-28

    if(argc < 3){
          printf("Sampling2 %s\n",SAMPLING2_VERSION);
#ifdef _VSSP32
          printf("Usage: sampling2 span sfreq[:lpf] adbit[:bitshift] numch [filename [tempdir [mode]]]\n");
#else
          printf("Usage: sampling2 span sfreq adbit numch [filename [tempdir [mode]]]\n");
#endif
          printf("\n");
          printf("         where  span ---- duration (sec)\n");
#ifdef _VSSP32
          printf("                sfreq ---- sampling frequency\n");
          printf("                           40,100,200,500 (for kHz)\n");
          printf("                           0.04,0.1,0.2,0.5,1,2,4,8,16,32,64 (for MHz)\n");
          printf("                     Note1: 32 and 64 are valid only for K5/VSSP32\n");
          printf("                     Note2: -VE means ""no use of digital filter"" at K5/VSSP32\n");
          printf("                            In case of +VE, relation between sampling frequency\n");
          printf("                            (Fs) and filter frequency(Ff) is as follows;\n");
          printf("                            Fs(MHz)   0.04 0.1 0.2 0.5 1 2 4 8 16 32 64\n");
          printf("                            Ff(MHz)     2   2   2   2  2 2 2 4  8 16  0\n");
          printf("                                   (valid for K5/VSSP32. 0 means through)\n");
          printf("                lpf   ---- set LPF frequency when u want to set idependently\n");
          printf("                           sfrom ampling frequency\n");
          printf("                             2,4,8,16,0 (MHz, 0 means through)\n");
#else
          printf("                sfreq ---- sampling frequency\n");
          printf("                           40,100,200,500 (for kHz)\n");
          printf("                           1,2,4,8,16 (for MHz)\n");
#endif
          printf("                adbit ---- A/D bit\n");
          printf("                           1,2,4,8\n");
          printf("                          default is 1\n");
#ifdef _VSSP32
          printf("                bitshift ---- # of bits to be shifted from 8 bit sampling data\n");
          printf("                           in case of 2bit or 4 bit sampling.\n");
          printf("                           0-6 (default is 0)\n");
#endif
          printf("                numch ---- number of channel\n");
          printf("                           1,4\n");
          printf("                          default is 1\n");
          printf("                filename ---- out file name\n");
          printf("                          default is tds.data\n");
          printf("                tempdir ---- every 1sec data out directory\n");
          printf("                          default is current directory\n");
          printf("                mode  ---- File out mode\n");
          printf("                          1: One big file only (default)\n");
          printf("                          2: Every 1 sec file only\n");
          printf("                          3: One big file + Every 1 sec file (simultaneously)\n");
          printf("                          4: Every 1 sec file, after Obs one big file created\n");
          printf("                          5: 3 + 4 for debug purpose (debug.dat will be created)\n");
          printf("                          6: Every 1 sec file out only but no time limitation");
          printf("                             (continuous running with ring file buffer\n");
          printf("                                 (max 10 files))\n");
          printf("                          7: same as 6 but no file out\n");
          printf("                             (performance check purpose)\n");
          exit(0);
    }

    spg.sp.vsspaux.fmt=2;  // default AUX field format for K5/VSSP32  (sampling)
    span = atoi(*(argv + 1 ));
    
    strcpy(cbuf,*(argv+2));
    parse_sfreq_lpf(cbuf, &sfreq, &spg.sp.filter, &freq);    // check ":" is in characters

    if (argc>=4) {
       strcpy(cbuf,*(argv+3));
       parse_adbit_bitshift(cbuf, &adbit, &spg.sp.bitshift);    // check ":" is in characters
    } else {
       adbit=1;
       spg.sp.bitshift=0;
    }

    if (argc>=5) {
        numch = atoi(*(argv + 4 ));
    } else {
        numch=1;
    }

    if (argc>=6) {
        strcpy(outfile,*(argv+5));
    } else {
        strcpy(outfile,dflt_fname);
    }
    
    if (argc>=7){
        strcpy(outdir,*(argv+6));
    } else {
        strcpy(outdir,dflt_tempdir);
    }
    /* check out dir name accompanied by "/" or not */
    i=strlen(outdir);
    //printf("i= %d\n",i);
    if(outdir[i-1] != '/') {
        outdir[i]='/';
        outdir[i+1]='\0';
    }
    
    if (argc>=8) {
        mode = atoi(*(argv + 7 ));
    } else {
        mode=1;
    }

    printf(" span    = %d\n",span);    // debug
#ifdef _VSSP32
    printf(" sfreq   = %d (freq(MHz) = %f)\n",sfreq,freq);   // debug
    if(spg.sp.filter==0){
       printf(" filter  = through\n");   // debug
    } else {
       printf(" filter  = %d (MHz)\n",spg.sp.filter);   // debug
    }
#else
    printf(" sfreq   = %d\n",sfreq);   // debug
#endif
    printf(" adbit   = %d\n",adbit);   // debug
#ifdef _VSSP32
    printf(" bitshift= %d\n",spg.sp.bitshift);   // debug
#endif
    printf(" numch   = %d\n",numch);   // debug
    printf(" outfile = %s\n",outfile);   // debug
    
#ifdef _VSSP32
    /* prepare AUX field for K5/VSSP32 */
    /* get host name for AUX filed */
    
    hostget(spg.sp.vsspaux.hostname8);
    strcpy(spg.sp.vsspaux.sid," ");
    strcpy(spg.sp.vsspaux.sid2,"  ");
    strcpy(spg.sp.vsspaux.station8,"sampling");
    spg.sp.vsspaux.size=20;  // this is fixed
    spg.sp.vsspaux.filter=spg.sp.filter;
    vssp_aux_make(&spg.sp.vsspaux);
#endif

    spg.span=span;
    spg.sp.sfreq=sfreq;
    spg.sp.adbit=adbit;
    spg.sp.numch=numch;
    strcpy(spg.outfile,outfile);
    strcpy(spg.outdir,outdir);

    //rv=sampleget4(outfile, span, sfreq, adbit, numch, outdir, mode);
    rv=sampleget4(&spg, mode);

    if(mode==1 || mode==3 || mode==4) {
       printf("Data File is %s\n",outfile);
    }
    if(mode==2 || mode==3 || mode==4) {
       printf("1sec Data out directory is %s\n",outdir);
    }
    

    return 0;
}
